#include <eo>
#include <iostream> 

#include <tcl.h>
#include <tk.h>

using namespace std;

#include "../strategy.h"
#include "../compete.h"
#include "../fitness.h"

// todo: get rid of global stuff
bool bstop;
bool bexit;
bool bnext; 
bool bprint;
bool bconfig; 
bool bcompete; 
bool bbestindi; 
bool bselect;
bool bset; 

// TODO  fuj -> jedna funkce a switch !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 
int stop( ClientData Data, Tcl_Interp *pInterp, int argc, const char *argv[] ) {
  //  printf("--------- STOP ----------- \n");
  bstop = true;
  return 0;
} 

int cont( ClientData Data, Tcl_Interp *pInterp, int argc, const char *argv[] ) {
  // printf("--------- CONTINUE ----------- \n");
  bstop = false;
  return 0;
} 

int exit( ClientData Data, Tcl_Interp *pInterp, int argc, const char *argv[] ) {
  //  printf("--------- EXIT ----------- \n");
  bstop = false; 
  bexit = true;
  return 0;
} 

int next( ClientData Data, Tcl_Interp *pInterp, int argc, const char *argv[] ) {
  // printf("--------- NEXT ----------- \n");
  bnext = true;
  return 0;
} 


int print( ClientData Data, Tcl_Interp *pInterp, int argc, const char *argv[] ) {
  // printf("--------- PRINT ----------- \n");
  bprint = true;
  return 0;
} 

int config( ClientData Data, Tcl_Interp *pInterp, int argc, const char *argv[] ) {
  bconfig = true;
  return 0;
} 

int compete(ClientData Data, Tcl_Interp *pInterp, int argc, const char *argv[]) {
  bcompete = true; 
  return 0; 
} 

int bestindi(ClientData Data, Tcl_Interp *pInterp, int argc, const char *argv[]) {
  bbestindi = true;
  return 0; 
} 

int selectStrat(ClientData Data, Tcl_Interp *pInterp, int argc, const char *argv[]) {
  bselect = true;
  return 0; 
}

int setStrat(ClientData Data, Tcl_Interp *pInterp, int argc, const char *argv[]) {
  bset = true;
  return 0; 
}


template <class EOT> class myGui : public eoContinue<EOT> {

public:

  myGui(double _from=0.0, double _to=1.0) : crossRate(dummy), mutRate(dummy), fit(dummyf){  
    bstop = true; bexit = false; bprint=false; 
    iter=0; from = _from; to = _to; 
    crossRateValid = mutRateValid = false; 
    Init(); 
  }; 

  myGui(double& _crossRate, double& _mutRate, 
	PrisonerDilemaFitness& _fit, 
	double _from=0.0, double _to=1.0) : crossRate(_crossRate), mutRate(_mutRate),
  fit (_fit) {  
    bstop = true; bexit = false; bprint=false; 
    iter=0; from = _from; to = _to; 
    crossRateValid = mutRateValid = true; 
    Init(); 
  }; 
  


  void Init() {
    interp = Tcl_CreateInterp() ;
    Tcl_Init(interp);

    int ret;
    ret = Tk_Init(interp);
  
    if (ret != TCL_OK) {
      printf("Unable to initialize TK.\n");
      printf(interp->result);
    } 

    Tcl_CreateCommand( interp, "c_stop", stop, (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL );
    Tcl_CreateCommand( interp, "c_continue", cont, (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL );
    Tcl_CreateCommand( interp, "c_exit", exit, (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL );
    Tcl_CreateCommand( interp, "c_next", next, (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL );
    Tcl_CreateCommand( interp, "c_print", print, (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL );
    Tcl_CreateCommand( interp, "c_config", config, (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL );
    Tcl_CreateCommand( interp, "c_compete", compete, (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL );
    Tcl_CreateCommand( interp, "c_print_bestindi", bestindi, (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL );
    Tcl_CreateCommand( interp, "c_select", selectStrat, (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL );
    Tcl_CreateCommand( interp, "c_set", setStrat, (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL );
    
    ret = Tcl_EvalFile(interp, "gui/gui.txt");
  
    if (ret != TCL_OK) {
      printf("Error during initial script.\n");
      printf(interp->result); 
    }

    char strFrom[10]; snprintf(strFrom,9,"%lf",from);  
    char strTo[10]; snprintf(strTo,9,"%lf",to);  
    Tcl_SetVar(interp, "f", strFrom, 0); 
    Tcl_SetVar(interp, "t", strTo, 0); 
  } 

  void draw(double value, bool mean=false) {

    
    const char *x = (mean) ? Tcl_GetVar(interp,"xp",0) : Tcl_GetVar(interp,"x",0);
    const char *y = (mean) ? Tcl_GetVar(interp,"yp",0) : Tcl_GetVar(interp,"y",0);


    const char *h = Tcl_GetVar(interp,"h",0);
    const char *f = Tcl_GetVar(interp,"f",0);
    const char *t = Tcl_GetVar(interp,"t",0);

    
    char x2[50];
    char xm[50];
    char y2[50];

    if (value < from) { value = from; printf("Warning: fitness out of range of graph.\n"); }
    if (value > to ) { value = to; printf("Warning: fitness out of range of graph.\n"); }

    sprintf(y2,"%lf",(atof(t)-value)*atof(h)/(atof(t)-atof(f)));
     
    //    printf( y2 );

    if (!strcmp(y,"start")) { // first call -  set initial value
      Tcl_SetVar(interp, (mean) ? "yp" : "y", y2, 0);
      return; 
    } 

    // draw line
    sprintf(x2,"%i",atoi(x)+5);
    sprintf(xm,"%i",atoi(x)-5000); // ??? tune the constant

    char drawline[100]; 
    char deltag[100]; 
    char conf[100]; 
    
    snprintf(drawline,99, 
	     ".graph.c create line %s %s %s %s  -fill %s -width 2 -tag x2\n",
	     x,y, 
	     x2,y2,
	     (mean)?"green":"red"); 

    snprintf(deltag,99, 
	     (mean) ? ".graph.c delete tag xp %s\n" : ".graph.c delete tag x %s\n",
	     xm); 

    snprintf(conf,99,
	     ".graph.c configure -scrollregion { %s 0 %s %s }\n",
	     xm, x2, h); 


    //    printf("%s %s %s",drawline, deltag, conf);

    int ret = Tcl_VarEval(interp,
			  drawline,deltag, conf, 
			  ".graph.c xview moveto 1\n", 
			  0);

    if (ret != TCL_OK) {
      printf("Drawing to graph failed.\n");
      printf(interp->result);
    }

    Tcl_SetVar(interp, (mean) ? "xp" : "x" , x2, 0);
    Tcl_SetVar(interp, (mean) ? "yp" : "y", y2, 0);
  } 

  void do_select() { 
    wait4set = true; 
    select(true); 
    while (wait4set) {
      Tcl_DoOneEvent(TCL_ALL_EVENTS | TCL_DONT_WAIT);
      if (bset) 
	set();
    }
  }


  virtual bool operator()(const eoPop<EOT>& _pop) {

    
    //    
    // cout << iter << ": "<<  _pop.best_element().fitness() << endl;
    //

    Tcl_SetVar(interp, "Generace",strIter(),0);
    double bestFit = _pop.best_element().fitness();
    //  eoPop<EOT> myPop1  = _pop;
    //    myPop1.sort();
    //  double bestFit = myPop1[0].fitness();
    
    double mean=0; 
    for (unsigned i=0; i<_pop.size(); i++) 
      mean += _pop[i].fitness(); 
    mean /= _pop.size(); 

    Tcl_SetVar(interp, "Fitnes",strFitness(bestFit),0); 

    if (crossRateValid) Tcl_SetVar(interp,"Cross",strDouble(crossRate),0);
    if (mutRateValid) Tcl_SetVar(interp,"Mut",strDouble(mutRate),0);

    draw(bestFit);     draw(mean,true); 
    iter++;


    bnext = false; 
    while (bstop && !bnext) { 

      Tcl_DoOneEvent(TCL_ALL_EVENTS);
 
      if (bprint) {
	eoPop<EOT> myPop  = _pop;
	myPop.sort();
	cout << myPop;
	bprint = false; 
      } 
    
      if (bconfig) {

	if (crossRateValid) {
	  double newCross = atof( Tcl_GetVar(interp,"Cross",0) );
	  if (newCross < 0.0 || newCross > 1.0) 
	    cout << "Crossover rate: out of range." << endl; 
	  else 
	    crossRate = newCross; 
	} 

	if (mutRateValid) {
	  double newMut = atof(Tcl_GetVar(interp,"Mut",0));
	  if (newMut < 0.0 || newMut > 1.0) 
	    cout << "Mutation rate: out of range." << endl; 
	  else 
	    mutRate = newMut; 
	} 

	bconfig = false; 
      }

      if (bselect) {
	select();
	bselect = false;
      }
      
      if (bset) {
	set();
	bset = false;
      }

      if (bbestindi) {
	//	eoPop<EOT> myPop  = _pop;
	//	myPop.sort();
	//	IndiStrategy best(myPop[0]);
	IndiStrategy best(_pop.best_element());
	best.print(); 
	bbestindi = false; 
      } 

      if (bcompete) {
	//	eoPop<EOT> myPop  = _pop;
	//	myPop.sort();
	//IndiStrategy best(myPop[0]);
	IndiStrategy best(_pop.best_element());

	int sum_results[fit.targetStrategies.size()]; 
	int bestResult;

	for (unsigned i=0; i<fit.targetStrategies.size(); i++) sum_results[i] = 0; 
	bestResult = 0;

	result res; 

	competition.setTrials(100,30);

	int n =0; 
	// compete 
	for (unsigned i=0; i< fit.targetStrategies.size(); i++) 
	  if (fit.stratEnabled[i]) {
	    n++;
	    for (unsigned j=0; j<i; j++) {
	      if (fit.stratEnabled[i] && fit.stratEnabled[j]) {
		res = competition( *fit.targetStrategies[i], *fit.targetStrategies[j] ); 
		
		sum_results[i] += res.first_player;
		sum_results[j] += res.second_player;
	      } 
	    } 
	  }
  
	competition.printOn(); 
	cout << "Competitions: " << endl; 
	
	for (unsigned i=0; i<fit.targetStrategies.size(); i++) {
	  if (fit.stratEnabled[i]) {
	    res = competition(best, *(fit.targetStrategies[i]));
	    bestResult += res.first_player; 
	    sum_results[i] += res.second_player;
	  }
	}

	for (unsigned i=0; i<fit.targetStrategies.size(); i++) 
	  cout << setw(30) << fit.targetStrategies[i]->getName() << ":  " << sum_results[i]/n << endl; 
	cout << setw(30) << best.getName() << ":  " << bestResult/n << endl; 

	ofstream fout("results.txt");
	for (unsigned i=0; i<fit.targetStrategies.size(); i++) 
	  fout << sum_results[i]/n << " " << fit.targetStrategies[i]->getName() << endl; 
	fout << bestResult/n << " " <<  best.getName() << endl; 
	
	fout.close();

	

	bcompete = false;
      } 

    }; 
   
    Tcl_DoOneEvent(TCL_ALL_EVENTS | TCL_DONT_WAIT);
    
    return !bexit;
  }


  int set() {

    string value; 
    string name;
    for (unsigned i=0; i<fit.stratNames.size(); i++) { 
      // get value of checkbox 
      name = "v" + fit.stratNames[i]; 
      value = Tcl_GetVar(interp,name.c_str(),0);
      if (value == "1") 
	fit.stratEnabled[i] = true;
      else 
	fit.stratEnabled[i] = false;
    } 
    
    int ret = Tcl_VarEval(interp,
			  "destroy .selekce",
			  0); 
    if (ret != TCL_OK) {
      printf(interp->result);
    }

    wait4set = false;
    return 0; 
  }
  
  int select(bool first=false)  {

    printf("--------- select ----------- \n");
    
    int ret = Tcl_VarEval(interp,
			  "toplevel .selekce \n",
			  0);
    if (ret != TCL_OK) {
      printf(interp->result);
    } 


    for (unsigned i=0; i<fit.stratNames.size(); i++) {
      
      
      ret = Tcl_VarEval(interp,
			"set v",fit.stratNames[i].c_str(),fit.stratEnabled[i] ? " 1 " : " 0 ","\n",
			"checkbutton .selekce.n",fit.stratNames[i].c_str()," -variable v",fit.stratNames[i].c_str()," -onvalue 1 -offvalue 0 -text \"",fit.stratNames[i].c_str(),"\" -command {}\n",
			"grid  .selekce.n",fit.stratNames[i].c_str()," -sticky ew -pady 2 -padx 1\n",
			0);
      if (ret != TCL_OK) {
	printf(interp->result);
      } 
    } 
    
    if (first) 
      ret = Tcl_VarEval(interp,
			"grid [button .selekce.exit -text \"Nastav\" -command { c_set }]\n",
			0);
    else 
      ret = Tcl_VarEval(interp,
			"grid [button .selekce.storno -text \"Storno\" -command { destroy .selekce }]\n",
			"grid [button .selekce.exit -text \"Nastav\" -command { c_set }]\n",
			0);

    if (ret != TCL_OK) {
      printf(interp->result);
    } 

  return 0; 
}

    
public:
  bool wait4set; 
  
private:
  Tcl_Interp *interp; 
  int iter; 
  
  double from, to; 

  char buf1[20]; // buffer for iter 
  char buf2[20]; // buffer for fitness  
  char buf3[20]; // buffer for fitness  

  const char *strIter() { snprintf(buf1,19,"%d",iter); return buf1; };
  const char *strFitness(double fitness) {  snprintf(buf2,19,"%lf",fitness); return buf2; }; 
  const char *strDouble(double x) {  snprintf(buf3,19,"%.2lf",x); return buf3; }; 

  double &crossRate;
  bool crossRateValid; 

  double &mutRate; 
  bool mutRateValid; 

  double dummy;
  PrisonerDilemaFitness dummyf; 

  Compete competition;

  PrisonerDilemaFitness& fit;
};



